/*==============================================================================
		文字列操作関数	for ＢｅＯＳ		Ver 1.00
		Copyright (C) 1999 by ＳＨＩＮＴＡ
		Last Modified 1999.02.26
==============================================================================*/

/*==============================================================================
 Ver. |					主な改良点
--------------------------------------------------------------------------------
 ---- | 1999.02.26.Fr 開発着手。
 1.00 | 1999.02.26.Fr オリジナルバージョン。trim()、trimleft()、trimright()。
 1.10 | 1999.02.26.Fr instr()を作った。
 1.20 | 1999.02.26.Fr mid()を作った。
==============================================================================*/

/*=== Memo =====================================================================
==============================================================================*/

#include "SHIString.h"
//------------------------------------------------------------------------------
unsigned int	instr(const char *szSrc,const char *szTgt,int iBegin)
{
	int				iCmpLen;
	unsigned int	iPos = 0;
	int				iSrcLen;
	int				iTgtLen;
	int				i;
	
	iSrcLen = strlen(szSrc);
	iTgtLen = strlen(szTgt);
	iCmpLen = (iSrcLen > iTgtLen) ? iTgtLen : iSrcLen;
	for ( i = iBegin-1 ; i <= iSrcLen-iTgtLen ; i++ ) {
		if ( strncmp(&szSrc[i],szTgt,iTgtLen) == 0 ) {
			iPos = i+1;
			break;
		}
	}
	return iPos;
}
//------------------------------------------------------------------------------
int		mid(char *szDest,const char *szSrc,int iBegin,int iMaxLen)
{
	int		iSrcLen;
	int		i;
	
	iSrcLen = strlen(szSrc);
	if ( iMaxLen == 0 || iBegin-1+iMaxLen > iSrcLen )
		iMaxLen = iSrcLen-iBegin+1;
	for ( i = iBegin-1 ; i < iBegin-1+iMaxLen ; i++ ) {
		szDest[i-(iBegin-1)] = szSrc[i];
	}
	szDest[i-(iBegin-1)] = '\0';
	return i-(iBegin-1);
}
//------------------------------------------------------------------------------
int		trim(char *szDest,const char *szSrc)
{
	int		i;
	
	trimleft(szDest,szSrc);
	i = strlen(szDest)-1;
	while ( isspace(szDest[i]) && i >= 0 )
		i--;
	szDest[i+1] = '\0';
	return i+1;
}
//------------------------------------------------------------------------------
int		trimleft(char *szDest,const char *szSrc)
{
	int		iSrcLen;
	int		i = 0;
	
	iSrcLen = strlen(szSrc);
	while ( isspace(szSrc[i]) && i < iSrcLen )
		i++;
	strcpy(szDest,&szSrc[i]);
	return iSrcLen-i;
}
//------------------------------------------------------------------------------
int		trimright(char *szDest,const char *szSrc)
{
	int		i;
	
	i = strlen(szSrc)-1;
	while ( isspace(szSrc[i]) && i >= 0 )
		i--;
	strncpy(szDest,szSrc,i+1);
	szDest[i+1] = '\0';
	return i+1;
}
//------------------------------------------------------------------------------
